Index: trunk/examples/extended/medical/DICOM/GNUmakefile
===================================================================
--- trunk/examples/extended/medical/DICOM/GNUmakefile	(revision 1230)
+++ trunk/examples/extended/medical/DICOM/GNUmakefile	(revision 1337)
@@ -1,3 +1,3 @@
-# $Id: GNUmakefile,v 1.3 2003/06/16 07:51:35 guatelli Exp $
+# $Id: GNUmakefile,v 1.4 2010/01/11 16:42:22 gcosmo Exp $
 # --------------------------------------------------------------
 # GNUmakefile for examples module.  Gabriele Cosmo, 06/04/98.
@@ -7,4 +7,8 @@
 G4TARGET := $(name)
 G4EXLIB := true
+
+ifndef G4INSTALL
+  G4INSTALL = ../../../..
+endif
 
 .PHONY: all
Index: trunk/examples/extended/medical/DICOM/History
===================================================================
--- trunk/examples/extended/medical/DICOM/History	(revision 1230)
+++ trunk/examples/extended/medical/DICOM/History	(revision 1337)
@@ -1,3 +1,3 @@
-$Id: History,v 1.13 2008/01/22 15:09:53 gcosmo Exp $
+$Id: History,v 1.22 2010/06/07 05:40:46 perl Exp $
 -------------------------------------------------------------------
 
@@ -8,4 +8,42 @@
                       Category History file
                       ---------------------
+06.06.2010 - Joseph Perl (DICOM-V09-03-03)
+	    Remove unused variable in EventAction 
+
+03.06.2010 - Joseph Perl (DICOM-V09-03-02)
+	    Updated vis usage
+
+19.11.2009- Stéphane Chauvie (DICOM-V09-03-00)
+01.06.2010- Stephane Chauvie - Andrea Armando 
+	    Added function to read nested items (defined and undefined)
+	    Removed dependencies on CONQUEST
+	    DICOM handler could now read whichever DICOM file (PT,CT,DR,CR,US,MR... ) 
+	    
+19.11.2009- Stephanee Chauvie (DICOM-V09-02-03)
+	    Changed DICOM Handler to read CT files coming from CONQUEST DICOM server
+
+05.02.2009 - Pedro Arce (DICOM-V09-02-01)
+             Added report on dose per voxel.
+             Added warning for erroneous inclusion of development code in
+             release 9.2 (to be removed when fix will be included in patch).
+
+27.01.2009 - Gabriele Cosmo (DICOM-V09-02-00)
+             Use new class G4RegularNavigationHistory for counting of step
+             lengths in voxels of the regular structure.
+
+27.11.2008 - Pedro Arce (DICOM-V09-01-02)
+             Included G4PSDoseDeposit_RegNav to distribute dose along voxels, 
+	     including msc and energy loss corrections, for the case of 
+	     skipping voxel with equal materials when using regular
+	     navigation
+
+21.07.2008 - Pedro Arce (DICOM-V09-01-01)
+             Bug fix in DicomNestedPhantomParameterisation in calculating the
+             'copyNo', so that material assignment was wrong
+             Set default cut to 1 mm (with previous 1.E-3 mm too much time is
+             spent on physics and no improvement is seen with different
+             navigation options).
+             Corrected direction and position of primary particles so that
+             they traverse the DICOM voxels.
 
 22.01.2008 - Pedro Arce (DICOM-V09-01-00)
Index: trunk/examples/extended/medical/DICOM/README
===================================================================
--- trunk/examples/extended/medical/DICOM/README	(revision 1230)
+++ trunk/examples/extended/medical/DICOM/README	(revision 1337)
@@ -18,4 +18,7 @@
 
 And it has been deeply reviewed by Pedro Arce in December 2007.
+Very small changes by Stephane Chauvie in January 2008.
+Stephane Chauvie, Oct 2009: changed Physics list; changes in DICOM read. 
+Stephane Chauvie and Andrea Armando; June 2010 adapted for reading  whatever DICOM file
 
 
@@ -30,9 +33,9 @@
 
  - A standard Geant4 example GNUmakefile is provided            
- - Compile it with 'make' 
+ - Compile it with 'make'/'gmake' 
 
 ---> 3) Run the example:
 
- - To run the environment variable G4LEDATA needs to be set, pointing to the low energy data base, G4EMLOW4.3      
+ - To run the environment variabmore le G4LEDATA needs to be set, pointing to the low energy data base
 
  - batch mode:
@@ -41,10 +44,10 @@
  - interactive mode:
    - $G4INSTALL/bin/Linux-g++/dicom
-   the file vis.mac is read in order to visualise the phantom with OpenGL
+   the file vis.mac is read in order to visualise the phantom with OpenGL, DAWN or VRML
 
 --->4) Metadata:
 
  The file Data.dat has the following information
-  - A line with the compression value (used only to create the .g4dcm, not to read it)
+  - A line with the compression value (used only to create the .g4dcm and .g4dcmb, not to read it)
   - A line with the number of files 
   - A line for each file name (to these names it will be added the suffix .dcm to read the DICOM files in their original format, and the suffix .g4dcm to read the text files that contain the DICOM information where the Hounsfield numbers have been converted to material and densities)
@@ -94,5 +97,5 @@
 The file Colormap.dat defines the colour that will be assigned to the voxels of each material.
 
---->8) DICOM text file format:
+--->8) DICOM file formats:
 
 The DICOM files are converted to a simple text format. You may create your own file with the following format (see e.g. 14196616.g4dcm):
@@ -109,12 +112,14 @@
 As commented before the DICOM files (.dcm) are assumed to describe one Z slice per file, and therefore the GEANT4 text files (.g4dcm) created from them have also one unique Z slice per file. Nevertheless if you create your own .g4dcm file you may include as many Z slices as desired. In any case you have to respect the rule that the Z slices must be contiguous.
 
+The same information is also used to fill a file in binary format, that contains the same information as the text format. Its name ends in .g4dcmb, instead of .g4dcm .
+
 --->9) Choosing different parameterisation/navigation options:
 
 There are four possible ways in GEANT4 to treat the navigation in regular voxelised volumes:
 
-- The non-optimised way. It will be very slow because each time a track exits a voxel it has to loop to all other voxels to know which one it may enter
-- The optimisation with G4SmartVoxel: a 3D grid is built, so that the location of voxels is fast, but it requires a lot of memory
+- The 1D optimisation . It will be very slow because each time a track exits a voxel it has to loop to all other voxels to know which one it may enter
+- The 3D optimisation with G4SmartVoxel: a 3D grid is built, so that the location of voxels is fast, but it requires a lot of memory
 - Using G4NestedParameterisation. The search is done hierarchically in X, Y and Z. It is fast and does not require big memory
-- Using G4PhantomParameterisation/G4RegularNavigation: an special algorithm to navigate in regular voxelised geometries (see GEANT4 doc). This is the fastest way without any extra memory requirement (and it is the default in this example). It includes an option (default) to skip frontiers between voxels when they have the same material
+- Using G4PhantomParameterisation/G4RegularNavigation: an special algorithm to navigate in regular voxelised geometries (see GEANT4 doc). This is the fastest way without any extra memory requirement (and it is the default in this example). It includes an option (default) to skip frontiers between voxels when they have the same material. When using this option at each step the energy is all deposited in the last voxel; for properly distribution of the dose (=energy/volume) the G4PSDoseDeposit_RegNav scorer can be used (see below)
 
 You can select amont the four options in the following way:
@@ -138,2 +143,19 @@
 - To use the third option you have to set the enviromental variable DICOM_NESTED_PARAM to 1
 
+
+--->10) Calculating dose in phantom voxels for regular navigation
+
+As mentioned above the regular navigation has the option to keip voxel frontiers when two voxels share the same material, what can make the CPU time several times smaller. But this option makes that all energy deposited is computed in the last voxel, instead of distributing it along the voxels traversed. To properly calculate the dose in each voxel the G4PSDoseDeposit_RegNav scorer can be used.
+It takes into account the fact that,  when the particle travels through the voxels it looses energy and therefore the energy lost per length (dEdx) is bigger and also the effect of the multiple scattering is bigger. 
+The algorithm to make this correction is an iterative one, as the step length increase due multiple scattering (that converts the geometrical step length in what we will call the true step length) and the energy loss are correlated.
+It works in the folloing way: first the total true step length is distributed among the voxels proportionally to their geometrical step length; with these values it is calculated one voxel after another the value of dEdx and then the value of the kinetic energy at the entrance of each voxel; with these values it is calculated the geometrical to true step corrections due to multiple scattering for each voxel; finally these new values are used to recalculate the energy lost in each voxel. It has been demonstrated for dose in a water phantom and in a real phantom that the two-step iteration described is enough to reproduce the dose calcualted when no skipping of voxel frontiers is done.
+
+This scorer is implemented in this examples if the regular navigation option is 
+chosen. It is triggered at the method RegularDicomDetectorConstruction::ConstructPatient() by the call
+
+SetScorer(voxel_logic);
+
+--->11) Output
+dicom.out is produced running th macro file run.mac. It has 2 columns: the first is the number of 
+voxel (ordered in x,y,z) and the second the dose there deposited (in Gy)
+It is produced, as an example, with a compression value of 32
Index: trunk/examples/extended/medical/DICOM/include/DicomDetectorConstruction.hh
===================================================================
--- trunk/examples/extended/medical/DICOM/include/DicomDetectorConstruction.hh	(revision 1230)
+++ trunk/examples/extended/medical/DICOM/include/DicomDetectorConstruction.hh	(revision 1337)
@@ -97,4 +97,5 @@
   std::vector<G4Material*> fMaterials;  // list of new materials created to distinguish different density voxels that have the same original materials
   size_t* fMateIDs; // index of material of each voxel
+ //unsigned int* fMateIDs; // index of material of each voxel
 
   std::map<G4int,G4double> fDensityDiffs; // Density difference to distinguish material for each original material (by index)
Index: trunk/examples/extended/medical/DICOM/include/DicomHandler.hh
===================================================================
--- trunk/examples/extended/medical/DICOM/include/DicomHandler.hh	(revision 1230)
+++ trunk/examples/extended/medical/DICOM/include/DicomHandler.hh	(revision 1337)
@@ -90,8 +90,11 @@
 
     void GetInformation(G4int &, char *);
-    G4double Pixel2density(G4int pixel);
+    G4float Pixel2density(G4int pixel);
     void ReadMaterialIndices( std::ifstream& finData);
-    size_t GetMaterialIndex( G4double density );
+    unsigned int GetMaterialIndex( G4float density );
     void StoreData(std::ofstream& foutG4DCM);
+    G4int read_defined_nested(FILE *, G4int);
+    void read_undefined_nested(FILE *);
+    void read_undefined_item(FILE *);
 
     short compression;
@@ -112,5 +115,5 @@
 
     G4int** tab;
-  std::map<G4double,G4String> fMaterialIndices;
+    std::map<G4float,G4String> fMaterialIndices;
 };
 #endif
Index: trunk/examples/extended/medical/DICOM/include/DicomNestedPhantomParameterisation.hh
===================================================================
--- trunk/examples/extended/medical/DICOM/include/DicomNestedPhantomParameterisation.hh	(revision 1230)
+++ trunk/examples/extended/medical/DICOM/include/DicomNestedPhantomParameterisation.hh	(revision 1337)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: DicomNestedPhantomParameterisation.hh,v 1.3 2009/01/27 10:44:58 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// $Id: DicomNestedPhantomParameterisation.hh,v 1.5 2009/11/19 16:15:23 chauvie Exp $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 // --------------------------------------------------------------------
@@ -76,8 +76,9 @@
       // of all instances with the same mother/ancestor volume
 
-    size_t GetMaterialIndex( size_t nx, size_t ny, size_t nz) const;
-    size_t GetMaterialIndex( size_t copyNo) const;
+    unsigned int GetMaterialIndex( unsigned int nx, unsigned int ny, unsigned int nz) const;
+    unsigned int GetMaterialIndex( unsigned int copyNo) const;
+    //void SetMaterialIndices( unsigned int* matInd ) { fMaterialIndices = matInd; }
     void SetMaterialIndices( size_t* matInd ) { fMaterialIndices = matInd; }
-    void SetNoVoxel( size_t nx, size_t ny, size_t nz );
+    void SetNoVoxel( unsigned int nx, unsigned int ny, unsigned int nz );
 
     void ComputeTransformation(const G4int no,
@@ -121,5 +122,5 @@
     std::vector<G4Material*> fMaterials;
     size_t* fMaterialIndices; // Index in materials corresponding to each voxel
+//    unsigned int* fMaterialIndices; // Index in materials corresponding to each voxel
 };
-
 #endif
Index: trunk/examples/extended/medical/DICOM/include/DicomPhysicsList.hh
===================================================================
--- trunk/examples/extended/medical/DICOM/include/DicomPhysicsList.hh	(revision 1230)
+++ trunk/examples/extended/medical/DICOM/include/DicomPhysicsList.hh	(revision 1337)
@@ -24,18 +24,7 @@
 // ********************************************************************
 //
-// The code was written by :
-//	*Louis Archambault louis.archambault@phy.ulaval.ca,
-//      *Luc Beaulieu beaulieu@phy.ulaval.ca
-//      +Vincent Hubert-Tremblay at tigre.2@sympatico.ca
-//
-//
-// *Centre Hospitalier Universitaire de Quebec (CHUQ),
-// Hotel-Dieu de Quebec, departement de Radio-oncologie
-// 11 cote du palais. Quebec, QC, Canada, G1R 2J6
-// tel (418) 525-4444 #6720
-// fax (418) 691 5268
-//
-// + Université Laval, Québec (QC) Canada
-//*******************************************************//
+// -------------------------------------------------------------------
+// $Id: DicomPhysicsList.hh,v 1.7 2009/10/26 11:21:01 chauvie Exp $
+// -------------------------------------------------------------------
 
 #ifndef DicomPhysicsList_h
@@ -43,9 +32,6 @@
 
 #include "G4VUserPhysicsList.hh"
-#include "globals.hh"
 
-class G4LowEnergyIonisation;
-class G4LowEnergyPhotoElectric;
-class G4LowEnergyBremsstrahlung;
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
 
 class DicomPhysicsList: public G4VUserPhysicsList
@@ -55,36 +41,24 @@
   ~DicomPhysicsList();
 
-  // Set Cuts
-  void SetGammaCut(G4double);
-  void SetElectronCut(G4double);
-  void SetPositronCut(G4double);
- 
-protected:
-  // Construct particle and physics
-  void ConstructParticle();
-  void ConstructProcess();
-
-  void SetCuts();
-
-  // these methods Construct particles
-  void ConstructBosons();
-  void ConstructLeptons();
-
-  // these methods Construct physics processes and register them
-  void ConstructGeneral();
-  void ConstructEM();
-
 private:
-
+  
   G4double cutForGamma;
   G4double cutForElectron;
   G4double cutForPositron;
+  
+protected:
+  
+  void ConstructParticle();
+  void ConstructBosons();
+  void ConstructLeptons();
+  void ConstructBaryons();
 
-  G4LowEnergyIonisation*  loweIon;
-  G4LowEnergyPhotoElectric* lowePhot;
-  G4LowEnergyBremsstrahlung* loweBrem;
-
+  void ConstructProcess();
+  void ConstructEM();
+  void ConstructHad();
+  void ConstructGeneral();
+  void SetCuts();
+  
 };
-
 #endif
 
Index: trunk/examples/extended/medical/DICOM/run.mac
===================================================================
--- trunk/examples/extended/medical/DICOM/run.mac	(revision 1230)
+++ trunk/examples/extended/medical/DICOM/run.mac	(revision 1337)
@@ -1,7 +1,30 @@
+# S. Chauvie
+#
+# Macro file recommended for the use with DICOM example and built-in physic list.
+# This macro uses the physics list already contained in the Geant4 distribution
+# 
+
+#########################
+# Set of the verboses 
+#
 /control/verbose 1
+/tracking/verbose 0
 /run/verbose 1
-/tracking/verbose 1
+/event/verbose 0
+
+
+##########################
+# Random
+#
+
 /random/setDirectoryName .
 /random/setSavingFlag 1
 #/random/resetEngineFrom currentEvent.rndm1
+
+
+##########################
+# Initialisation procedure
+#
+/run/initialize
+
 /run/beamOn 100
Index: trunk/examples/extended/medical/DICOM/src/DicomDetectorConstruction.cc
===================================================================
--- trunk/examples/extended/medical/DICOM/src/DicomDetectorConstruction.cc	(revision 1230)
+++ trunk/examples/extended/medical/DICOM/src/DicomDetectorConstruction.cc	(revision 1337)
@@ -314,5 +314,5 @@
   G4double densityDiff = 0.1; 
   std::map<G4int,G4double>  fDensityDiffs; // to be able to use a different densityDiff for each material
-  for( size_t ii = 0; ii < fOriginalMaterials.size(); ii++ ){
+  for( unsigned int ii = 0; ii < fOriginalMaterials.size(); ii++ ){
     fDensityDiffs[ii] = densityDiff; //currently all materials with same difference
   }
@@ -327,8 +327,10 @@
   //--- If first slice, initiliaze fMateIDs
   if( fZSliceHeaders.size() == 1 ) {
+    //fMateIDs = new unsigned int[fNoFiles*nVoxels];
     fMateIDs = new size_t[fNoFiles*nVoxels];
-  }
-
-  size_t mateID;
+
+  }
+
+  unsigned int mateID;
   G4int voxelCopyNo = (fZSliceHeaders.size()-1)*nVoxels; // number of voxels from previously read slices
   for( G4int ii = 0; ii < nVoxels; ii++, voxelCopyNo++ ){
@@ -353,5 +355,5 @@
     
     //-- Look if a material with this name is already created (because a previous voxel was already in this density bin)
-    size_t im;
+    unsigned int im;
     for( im = 0; im < fMaterials.size(); im++ ){
       if( fMaterials[im]->GetName() == newMateName ) {
@@ -377,5 +379,5 @@
   //----- Images must have the same dimension ... 
   fZSliceHeaderMerged = new DicomPatientZSliceHeader( *fZSliceHeaders[0] );
-  for( size_t ii = 1; ii < fZSliceHeaders.size(); ii++ ) {
+  for( unsigned int ii = 1; ii < fZSliceHeaders.size(); ii++ ) {
     *fZSliceHeaderMerged += *fZSliceHeaders[ii];
   };
Index: trunk/examples/extended/medical/DICOM/src/DicomEventAction.cc
===================================================================
--- trunk/examples/extended/medical/DICOM/src/DicomEventAction.cc	(revision 1230)
+++ trunk/examples/extended/medical/DICOM/src/DicomEventAction.cc	(revision 1337)
@@ -42,7 +42,4 @@
 #include "DicomEventAction.hh"
 #include "G4Event.hh"
-#include "G4TrajectoryContainer.hh"
-#include "G4Trajectory.hh"
-#include "G4VVisManager.hh"
 
 DicomEventAction::DicomEventAction():drawFlag("all")
@@ -55,28 +52,7 @@
 {
   G4cout << "EV: " << evt->GetEventID() << G4endl;
- }
-
-void DicomEventAction::EndOfEventAction(const G4Event* evt)
-{
-  // extract the trajectories and draw them
-
-  if (G4VVisManager::GetConcreteInstance())
-    {
-      G4TrajectoryContainer * trajectoryContainer = evt->GetTrajectoryContainer();
-      G4int nTrajectories = 0;
-      if ( trajectoryContainer )
-	nTrajectories = trajectoryContainer->entries();
-
-      for ( G4int i = 0;i < nTrajectories; i++ )
-        {
-	  G4Trajectory* trj = (G4Trajectory*)((*(evt->GetTrajectoryContainer()))[i]);
-	  if (drawFlag == "all")
-	    trj->DrawTrajectory(50);
-	  else if ((drawFlag == "charged")&&(trj->GetCharge() != 0.))
-	    trj->DrawTrajectory(50);
-	  else if ((drawFlag == "neutral")&&(trj->GetCharge() == 0.))
-	    trj->DrawTrajectory(50);
-        }
-    }
 }
 
+void DicomEventAction::EndOfEventAction(const G4Event*)
+{
+}
